"{ Package: 'exept:regression' }"

"{ NameSpace: RegressionTests }"

TestCase subclass:#ProcessTest
	instanceVariableNames:'subProcesses'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-Regression'
!


!ProcessTest methodsFor:'test'!

tearDown

    subProcesses do:[:aProcess|
        aProcess terminate.
    ].
!

testTerminateWithAllSubProcesses

    | block masterTask allProcesses|

    subProcesses := OrderedCollection new.
    block := [ 
        1 to:10 do:[:index|
            |subTask|
            subTask := [[true] whileTrue:[]] newProcess.
            subTask name:'TestTask no:', index asString.
            subTask priority:4.
            subProcesses add:subTask.
            subTask resume.
        ].
        Delay waitForSeconds:10.
    ].

    masterTask := block newProcess.
    masterTask priority:8.
    masterTask name:'masterTask'.
    masterTask resume.

    Delay waitForSeconds:0.5.

    masterTask terminateWithAllSubprocesses.
    masterTask waitUntilTerminated.          
    allProcesses := ProcessorScheduler knownProcesses asOrderedCollection.
    subProcesses do:[:aProcess|
        self should:((allProcesses includes:aProcess) not).
    ].
"
    self new test
"
! !

!ProcessTest class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
